﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using DirectX = Microsoft.DirectX;

namespace HaloMap
{
    public class Globals
    {
        #region Fields
        //Update
        public static double Version = 1.2;
        public static string ServerPath = "http://allenthinks.com/grimdoomer/Gravemind/";
        public static string UpdateFile = "Update.xml";
        public static string UpdateName = "GravemindUpdate.zip";
        public static bool CheckForUpdates = false;
        public static bool UpdateWithoutPrompt = false;

        //Map Paths
        public static string Shared;
        public static string MainMenu;
        public static string SingleplayerShared;

        //Collision
        public static Color SphereColor = Color.Blue;
        public static Color WorldColor = Color.Black;
        public static DirectX.Direct3D.FillMode FillMode = Microsoft.DirectX.Direct3D.FillMode.WireFrame;
        
        //Unicode
        public static int[] uniDwords = new int[35];
        public static string[] uniTranslations = new string[35];
        #endregion

        #region Intialization
        public static void Initialize()
        {
            //Settings
            if (!File.Exists(Application.StartupPath + "\\Settings\\Settings.cfg"))
            {
                MessageBox.Show("Please set settings!", "Settings");
                return;
            }

            StreamReader sr = new StreamReader(new FileStream(Application.StartupPath + "\\Settings\\Settings.cfg", FileMode.Open, FileAccess.Read, FileShare.Read));
            Shared = sr.ReadLine();
            MainMenu = sr.ReadLine();
            SingleplayerShared = sr.ReadLine();
            CheckForUpdates = bool.Parse(sr.ReadLine());
            UpdateWithoutPrompt = bool.Parse(sr.ReadLine());
            sr.Close();

            //Collision
            if (!File.Exists(Application.StartupPath + "\\Settings\\Collision.cfg"))
            {
                MessageBox.Show("Please set Collision settings!", "Settings");
                return;
            }

            sr = new StreamReader(Application.StartupPath + "\\Settings\\Collision.cfg");
            SphereColor = Color.FromArgb(Convert.ToInt32(sr.ReadLine()));
            WorldColor = Color.FromArgb(Convert.ToInt32(sr.ReadLine()));
            FillMode = (DirectX.Direct3D.FillMode)Convert.ToInt32(sr.ReadLine());
            sr.Close();

            //1
            uniDwords[0] = -30575;
            uniDwords[1] = -30319;
            uniDwords[2] = -30063;
            uniDwords[3] = -24700;
            uniDwords[4] = -24956;
            uniDwords[5] = -21884;
            uniDwords[6] = -25212;
            uniDwords[7] = -27260;
            uniDwords[8] = -23164;
            uniDwords[9] = -23420;
            uniDwords[10] = -27516;
            uniDwords[11] = -26748;
            uniDwords[12] = -28028;
            uniDwords[13] = -25724;
            uniDwords[14] = -25980;
            uniDwords[15] = -24444;
            uniDwords[16] = -24188;
            uniDwords[17] = -23932;
            uniDwords[18] = -23676;
            uniDwords[19] = -22908;
            uniDwords[20] = -22396;
            uniDwords[21] = -27772;
            uniDwords[22] = -25468;
            uniDwords[23] = -27004;

            //2
            uniDwords[24] = -23920;
            uniDwords[25] = -29551;
            uniDwords[26] = -28527;
            uniDwords[27] = -26735;
            uniDwords[28] = -26991;
            uniDwords[29] = -24943;
            uniDwords[30] = -28271;
            uniDwords[31] = -29295;
            uniDwords[32] = -32380;
            uniDwords[33] = -31100;
            uniDwords[34] = -32636;

            uniTranslations[0] = "(X)";
            uniTranslations[1] = "(Y)";
            uniTranslations[2] = "(B)";
            uniTranslations[3] = "[Energy Sword]";
            uniTranslations[4] = "[Plasma Rifle]";
            uniTranslations[5] = "[Brute Plasma Rifle]";
            uniTranslations[6] = "[Plasma Pistol]";
            uniTranslations[7] = "[Covenant Carbine]";
            uniTranslations[8] = "[Disintegrator]";
            uniTranslations[9] = "[Beam Rifle]";
            uniTranslations[10] = "[Brute Shot]";
            uniTranslations[11] = "[Fuel Rod Cannon]";
            uniTranslations[12] = "[Battle Rifle]";
            uniTranslations[13] = "[Needler]";
            uniTranslations[14] = "[Magnum]";
            uniTranslations[15] = "[Rocket Launcher]";
            uniTranslations[16] = "[Shotgun]";
            uniTranslations[17] = "[SMG]";
            uniTranslations[18] = "[Sniper Rifle]";
            uniTranslations[19] = "[Sentinal Beam]";
            uniTranslations[20] = "[Sentinal Grenade Launcher]";
            uniTranslations[21] = "[BOMB]";
            uniTranslations[22] = "[ODDBALL]";
            uniTranslations[23] = "[FLAG]";

            //2
            uniTranslations[24] = "[Num]";
            uniTranslations[25] = "(LT)";
            uniTranslations[26] = "(Left Analog Stick)";
            uniTranslations[27] = "(Right Analog Stick Up Down)";
            uniTranslations[28] = "(Left Analog Stick 2)";
            uniTranslations[29] = "(Left Trigger 2)";
            uniTranslations[30] = "(Right Analog Stick Left Right)"; //?
            uniTranslations[31] = "(Right Trigger)";
            uniTranslations[32] = "[Banshee Boost]";
            uniTranslations[33] = "(Left Trigger 3)";
            uniTranslations[34] = "(Start)";
        }
        #endregion
    }

    [Serializable()]
    public class ClipboardContainer
    {
        #region Fields
        public string Name;
        public byte[] Data;
        public bool IsChunk = false;
        #endregion
    }
}
